package com.glxp.mipsdl.constant;

/**
 * 常量类
 */
public interface Constants {

    //接口名称

    /**
     * 获取往来单位接口URL名称
     */
    public static final String URL_NAME_CORP_URL = "corpUrl";

    /**
     * 获取产品信息接口URL名称
     */
    public static final String URL_NAME_PI_QUERY_URL = "piQueryUrl";

    /**
     * 获取单据类型列表接口URL名称
     */
    public static final String URL_NAME_BUS_TYPE_QUERY_URL = "busTypeQueryUrl";

    /**
     * 提交单据接口URL名称
     */
    public static final String URL_NAME_ORDER_SUBMIT_URL = "orderSubmitUrl";

    /**
     * 获取库存产品接口URL名称
     */
    public static final String URL_NAME_INV_PI_URL = "invPiUrl";

    /**
     * 获取仓库（科室）字典接口URL名称
     */
    public static final String URL_NAME_WAREHOUSE_QUERY_URL = "warehouseQueryUrl";

    /**
     * 查询单据列表接口URL名称
     */
    public static final String URL_NAME_ORDER_QUERY_URL = "orderQueryUrl";

    /**
     * 新增产品接口URL名称
     */
    public static final String URL_NAME_PRODUCT_SUBMIT_URL = "productSubmitUrl";

    /**
     * 提交预入库单据接口URL名称
     */
    public static final String URL_NAME_PRE_IN_ORDER_SUBMIT_URL = "preInOrderSubmit";

    /**
     * 新增往来单位接口URL名称
     */
    public static final String URL_NAME_UNIT_SUBMIT_URL = "unitSubmitUrl";

    //上传数据到UDI管理系统URL名称合集

    /**
     * 上传产品信息
     */
    public static final String URL_NAME_POST_THR_PRODUCTS_URL = "/udiwms/thrsys/postThrProducts";

    /**
     * 上传往来单位数据
     */
    public static final String URL_NAME_POST_THR_CORPS_URL = "/udiwms/thrsys/postCorps";

    /**
     * 上传单据
     */
    public static final String URL_NAME_POST_THR_ORDER_URL = "/udiwms/thrsys/postFileOrder";

    /**
     * 上传库存产品
     */
    public static final String URL_NAME_POST_THR_INV_PRODUCTS_URL = "/udiwms/thrsys/postInvProducts";

    /**
     * 查询UDI管理系统库存
     */
    public static final String URL_NAME_UDIWMS_PRODUCTS_FILTER_URL = "/udiwms/inv/products/filter";


    //往来单位类型

    /**
     * 病人
     */
    public static final int CORP_SICK = 1;

    /**
     * 供应商
     */
    public static final int CORP_SP = 2;

    /**
     * 内部科室等
     */
    public static final int CORP_INTTERNAL = 3;

    /**
     * 特殊往来
     */
    public static final int CORP_SPECIAL = 4;

    /**
     * 医院客户
     */
    public static final int CORP_HOSPTIAL = 5;


    //单据状态类型

    /**
     * 业务单据上传至第三方
     */
    public static final int THIRD_ORDER_UPLOAD = 1;

    /**
     * 接收第三方上传扫码单据
     */
    public static final int THIRD_ORDER_RECEIVE = 2;

}
