package com.glxp.mipsdl.entity.thrsys;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;

import java.util.Date;

@Data
@TableName(value = "thr_products")
public class ThrProductsEntity extends Model<ThrProductsEntity> {

    @TableId(value = "id", type = IdType.INPUT)
    private Long id;

    /**
     * 产品编码
     */
    @TableField(value = "code")
    private String code;

    /**
     * 通用名称
     */
    @TableField(value = "`name`")
    private String name;

    /**
     * 计量单位
     */
    @TableField(value = "measname")
    private String measname;

    @TableField(value = "spec")
    private String spec;

    /**
     * 注册证号
     */
    @TableField(value = "registerNo")
    private String registerNo;

    /**
     * 生产厂家
     */
    @TableField(value = "manufactory")
    private String manufactory;

    @TableField(value = "thirdSysFk")
    private String thirdSysFk;

    /**
     * 产品类别
     */
    @TableField(value = "cplb")
    private String cplb;

    /**
     * 分类编码
     */
    @TableField(value = "flbm")
    private String flbm;

    /**
     * 器械类别
     */
    @TableField(value = "qxlb")
    private String qxlb;

    /**
     * 医保编码
     */
    @TableField(value = "ybbm")
    private String ybbm;

    /**
     * 商品条码
     */
    @TableField(value = "sptm")
    private String sptm;

    /**
     * 注册人社会信用号
     */
    @TableField(value = "tyshxydm")
    private String tyshxydm;

    /**
     * 注册证 备案证号
     */
    @TableField(value = "zczbhhzbapzbh")
    private String zczbhhzbapzbh;

    /**
     * 注册/备案人名称
     */
    @TableField(value = "ylqxzcrbarmc")
    private String ylqxzcrbarmc;

    /**
     * 注册/备案人英文名称
     */
    @TableField(value = "ylqxzcrbarywmc")
    private String ylqxzcrbarywmc;

    /**
     * 产品描述
     */
    @TableField(value = "cpms")
    private String cpms;

    /**
     * 更新时间
     */
    @TableField(value = "updateTime")
    private Date updateTime;

    /**
     * 供应商名称
     */
    @TableField(value = "supName")
    private String supName;

    /**
     * 型号
     */
    @TableField(value = "model")
    private String model;

    /**
     * 规格型号（规格型号二合一字段）
     */
    @TableField(value = "`standard`")
    private String standard;

    /**
     * 其他编码
     */
    @TableField(value = "qtbm")
    private String qtbm;

    /**
     * 注册证有效期截止时间
     */
    @TableField(value = "zczyxqz")
    private String zczyxqz;

    /**
     * 备注 备注字段暂未启用，为保留字段
     */
    @TableField(value = "remark")
    private String remark;

    /**
     * 备注1
     */
    @TableField(value = "remark1")
    private String remark1;

    /**
     * 备注2
     */
    @TableField(value = "remark2")
    private String remark2;

    /**
     * 备注3
     */
    @TableField(value = "remark3")
    private String remark3;

    /**
     * 价格
     */
    @TableField(value = "price")
    private String price;

    /**
     * 创建人
     */
    @TableField(value = "`createUser`")
    private String createUser;

    /**
     * 创建时间
     */
    @TableField(value = "createTime")
    private Date createTime;

    /**
     * 更新人
     */
    @TableField(value = "updateUser")
    private String updateUser;

    /**
     * 生产厂家编码
     */
    @TableField("manufactoryCode")
    private String manufactoryCode;

    /**
     * 配送企业编码
     */
    @TableField("supCode")
    private String supCode;

}